require "util"
require "defines"

script.on_init(function()
   global.pollution_spawner = 0
   global.neutral_pollution = 0
   global.evolution_faktor = 0
   game.map_settings.enemy_evolution.time_factor =  0
   game.map_settings.enemy_evolution.pollution_factor =  0
   game.map_settings.enemy_evolution.destroy_factor =  0
end)

script.on_configuration_changed(function(data)
	if data.mod_changes ~= nil and data.mod_changes["Rescaled-Evolution-Factor"] ~= nil and data.mod_changes["Rescaled-Evolution-Factor"].old_version == nil then
		global.pollution_spawner = 0
		global.neutral_pollution = 0
		global.evolution_faktor = 0
		game.map_settings.enemy_evolution.time_factor =  0
		game.map_settings.enemy_evolution.pollution_factor =  0
		game.map_settings.enemy_evolution.destroy_factor =  0
	end
 end)
 
 script.on_load(function()
	if remote.interfaces.EvoGUI ~= nil then registriere_sensoren() end
	if global.pollution_spawner == nil then global.pollution_spawner = 0
	if global.neutral_pollution == nil then global.neutral_pollution = 0
	if global.evolution_faktor == nil then global.evolution_faktor = 0
 end)

function pollutiontest(event)
    if game.tick % 60 == 24 then
		if remote.interfaces.EvoGUI ~= nil then registriere_sensoren() end

		local summe = 1 --Gesamtwert der Verschmutzung
		local anzahl = 1 --Anzahl der Chunks
      
		local s = game.surfaces["nauvis"]
	  
		for c in s.get_chunks() do
			summe = summe + s.get_pollution({c.x *32,c.y *32})
			anzahl = anzahl + 1
		end
		
		local summe_anzahl = summe/math.log(anzahl)
		
		global.neutral_pollution = global.neutral_pollution + (summe_anzahl - global.neutral_pollution) * 0.01
		
		local pollution_wertung = summe_anzahl - global.neutral_pollution
		
		if pollution_wertung >= 0 then
			pollution_wertung = math.log(pollution_wertung) * 0.000002
		else
			pollution_wertung = math.log(pollution_wertung * -1) * -0.000002
		end
	  
		local vergangene_zeit = 0.2
	  
		if game.tick < 5184000 then --5184000 Ticks = 24 Stunden
			vergangene_zeit = math.pow(game.tick / 5184000, 2) * 0.2 --(Gewichtung = 20%)
		end
		
		local spawner_wertung = 0.3
	  
		if global.pollution_spawner < 60 then
			spawner_wertung = global.pollution_spawner / 200 -- (Gewichtung = 30%)
		end
	  
		global.evolution_faktor = global.evolution_faktor + pollution_wertung
	  
		if global.evolution_faktor > 0.8 then
			global.evolution_faktor = 0.8
		elseif global.evolution_faktor < 0 then
			global.evolution_faktor = 0
		end
	  
		game.evolution_factor = global.evolution_faktor	+ vergangene_zeit  + spawner_wertung
		
		if remote.interfaces.EvoGUI ~= nil then
			remote.call("EvoGUI", "update_remote_sensor", "rescaled_evolution_factor_sensor_pollution", {"", {"rescaled_evolution_factor_sensor_pollution_prefix"}, " ", summe_formatieren(summe)})
			remote.call("EvoGUI", "update_remote_sensor", "rescaled_evolution_factor_sensor_spawner", {"", {"rescaled_evolution_factor_sensor_spawner_prefix"}, " ", global.pollution_spawner})
			remote.call("EvoGUI", "update_remote_sensor", "rescaled_evolution_factor_sensor_anteile", {"", {"rescaled_evolution_factor_sensor_anteile_prefix"}, " ", string.format("%.1f", vergangene_zeit * 100).."%|", string.format("%.1f", spawner_wertung * 100).."%|", string.format("%.1f", global.evolution_faktor * 100).."%"})
		end
	end
   
    if (game.tick % 108000 == 25 and global.pollution_spawner > 0) then
		global.pollution_spawner = global.pollution_spawner -1 --Vergiss mit der Zeit alte Fehden.
	end
end

function spawnertot(event)
   if (global.pollution_spawner < 60 and (event.entity.name == "spitter-spawner" or event.entity.name == "biter-spawner")) then
      global.pollution_spawner = global.pollution_spawner + 1
   end   
end

function registriere_sensoren()
	if global.ist_registriert == nil then
		local sensor_data = {mod_name = "Evolve Factor",
							 name = "rescaled_evolution_factor_sensor_pollution",
							 text = {"rescaled_evolution_factor_sensor_pollution_display", 42},
							 caption = {"rescaled_evolution_factor_sensor_pollution_caption"}}
   
		remote.call("EvoGUI", "create_remote_sensor", sensor_data)
   
		sensor_data = {mod_name = "Evolve Factor",
					   name = "rescaled_evolution_factor_sensor_spawner",
					   text = {"rescaled_evolution_factor_sensor_spawner_display", 42},
					  caption = {"rescaled_evolution_factor_sensor_spawner_caption"}}
   
		remote.call("EvoGUI", "create_remote_sensor", sensor_data)
   
		sensor_data = {mod_name = "Evolve Factor",
					   name = "rescaled_evolution_factor_sensor_anteile",
					   text = {"rescaled_evolution_factor_sensor_anteile_display", 42},
					   caption = {"rescaled_evolution_factor_sensor_anteile_caption"}}
   
		remote.call("EvoGUI", "create_remote_sensor", sensor_data)
		
		global.ist_registriert = true
	end
end

function summe_formatieren(v)
	local s = string.format("%d", math.floor(v))
	local pos = string.len(s) % 3
	if pos == 0 then pos = 3 end
	return string.sub(s, 1, pos) .. string.gsub(string.sub(s, pos+1), "(...)", " %1")
end

function prozent_formatieren(v)
    local whole_number = math.floor(v)
    local fractional_component = math.floor((v - whole_number) * 10)
	
	return string.format("%d.%d%%", whole_number, fractional_component)
end

script.on_event(defines.events.on_tick, pollutiontest)
script.on_event(defines.events.on_entity_died , spawnertot)